#include <stdio.h>
#include "MkaeApi.h"

#ifdef _MSC_VER
#define snprintf _snprintf_s
#endif

MkaeAPI::MkaeAPI()
        : m_hinst_mkae(NULL)
{
        if (m_hinst_mkae)
                return;         // error

        m_hinst_mkae = (HINSTANCE)::GetModuleHandle(NULL);
        if (NULL == m_hinst_mkae) {
                return;         // error
        }

        // Get..
        if (NULL == 
            ((FARPROC&)GetFocusHandleByItemIndex = 
             GetProcAddress(m_hinst_mkae, "Mkae_GetFocusHandleByItemIndex"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)GetFocusHandleSelected = 
             GetProcAddress(m_hinst_mkae, "Mkae_GetFocusHandleSelected"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)GetHandleByItemIndex = 
             GetProcAddress(m_hinst_mkae, "Mkae_GetHandleByItemIndex"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)GetHandleSelected = 
             GetProcAddress(m_hinst_mkae, "Mkae_GetHandleSelected"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)GetItemIndexSelected = 
             GetProcAddress(m_hinst_mkae, "Mkae_GetItemIndexSelected"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)GetList = 
             GetProcAddress(m_hinst_mkae, "Mkae_GetList"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)GetInitialList = 
             GetProcAddress(m_hinst_mkae, "Mkae_GetInitialList"))) 
                goto ERROR_RETURN;

        if (NULL ==
            ((FARPROC&)GetPosition = 
             GetProcAddress(m_hinst_mkae, "Mkae_GetPosition"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)GetQuickOption = 
             GetProcAddress(m_hinst_mkae, "Mkae_GetQuickOption"))) 
                goto ERROR_RETURN;

        if (NULL ==
            ((FARPROC&)GetStatus = 
             GetProcAddress(m_hinst_mkae, "Mkae_GetStatus"))) 
                goto ERROR_RETURN;

        if (NULL ==
            ((FARPROC&)GetVersion = 
             GetProcAddress(m_hinst_mkae, "Mkae_GetVersion"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)GetWindowHandles = 
             GetProcAddress(m_hinst_mkae, "Mkae_GetWindowHandles"))) 
                goto ERROR_RETURN;

        // Set..
        if (NULL == 
            ((FARPROC&)SetCursorByItemIndex = 
             GetProcAddress(m_hinst_mkae, "Mkae_SetCursorByItemIndex"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)SetCursorByHandle = 
             GetProcAddress(m_hinst_mkae, "Mkae_SetCursorByHandle"))) 
                goto ERROR_RETURN;

        if (NULL ==
            ((FARPROC&)RegisterFocus = 
             GetProcAddress(m_hinst_mkae, "Mkae_RegisterFocus"))) 
                goto ERROR_RETURN;

        if (NULL ==
            ((FARPROC&)UnregisterFocus = 
             GetProcAddress(m_hinst_mkae, "Mkae_UnregisterFocus"))) 
                goto ERROR_RETURN;

        if (NULL ==
            ((FARPROC&)RegisterCustomList = 
             GetProcAddress(m_hinst_mkae, "Mkae_RegisterCustomList"))) 
                goto ERROR_RETURN;

        if (NULL ==
            ((FARPROC&)UnregisterCustomList = 
             GetProcAddress(m_hinst_mkae, "Mkae_UnregisterCustomList"))) 
                goto ERROR_RETURN;

        if (NULL ==
            ((FARPROC&)EnterMode = 
             GetProcAddress(m_hinst_mkae, "Mkae_EnterMode"))) 
                goto ERROR_RETURN;

        if (NULL ==
            ((FARPROC&)ExitMode = 
             GetProcAddress(m_hinst_mkae, "Mkae_ExitMode"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)SuspendHook = 
             GetProcAddress(m_hinst_mkae, "Mkae_SuspendHook"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)UpdateList = 
             GetProcAddress(m_hinst_mkae, "Mkae_UpdateList"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)SendHotKey = 
             GetProcAddress(m_hinst_mkae, "Mkae_SendHotKey"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)ReloadMenu = 
             GetProcAddress(m_hinst_mkae, "Mkae_ReloadMenu"))) 
                goto ERROR_RETURN;

        if (NULL == 
            ((FARPROC&)PrintErrRaw = 
             GetProcAddress(m_hinst_mkae, "Mkae_PrintErrRaw"))) 
                goto ERROR_RETURN;

        return;                 // normal

 ERROR_RETURN:
        if (m_hinst_mkae)
                m_hinst_mkae = NULL;
        return;                 // error
}

// PrintErrRaw tŎgp邽߂̃bp[
void
MkaeAPI::PrintErr(const char * i_uname, const char * i_fmt, ...)
{
        if (NULL == PrintErrRaw) return;
        if (*i_uname == '\0') return; // i_unamew͋Ȃ

        /* ό̏to */
        char buf[MAX_LOGSIZ];
        va_list args;
        va_start(args, i_fmt);
#ifdef _MSC_VER
        vsnprintf_s(buf, sizeof(buf), _TRUNCATE, i_fmt, args);
#else
        vsnprintf(buf, sizeof(buf), i_fmt, args);
#endif
        va_end(args);

        char tmp[MAX_LOGSIZ];
        snprintf(tmp, sizeof(tmp), "%s:%s", i_uname, buf);
        PrintErrRaw(tmp);
}
