#ifndef GETMKAELIST_H
#define GETMKAELIST_H

/* 
 * ̃t@ĆAȉ̓̃NX܂݂܂B
 *   a. ւ(\)Xg擾
 *   b. ւ̓\񃊃Xg擾
 *
 * a. ւ̃Xg擾 ̎g
 *       class GetMkaeList mkaelist;
 *       for (MkaeList_t *p = mkaelist.first(); p != NULL; p = mkaelist.next(p)) {
 *           ...
 *       }
 *
 *   b. ւ̓\񃊃Xg擾 ̎g
 *       class GetMkaeInitialList mkaeinitiallist;
 *       for (MkaeInitialList_t *p = mkaeinitiallist.first();
 *            p != NULL; p = mkaeinitiallist.next(p)) {
 *           ...
 *       }
 */
#include "MkaeApi.h"
#include "Plugin.h"

template <class T>
class GetMkaeListBase {
 public:
        GetMkaeListBase() : buf(NULL), n(0) {
        }
        virtual ~GetMkaeListBase() {
                // 擾obt@폜
                if (buf) free(buf);
        }
        T *first() {
                return (T *)buf;
        }
        T *next(T * cur) {
                cur++;
                if ((char *)cur >= lim)
                        return NULL;
                return cur;
        }
        int count() {
                return n;
        }
 protected:
        MkaeAPI MkaeApi;
        void make(int (WINAPI *getfunc)(char *, int *)) {
                // ܂̓TCY擾 ..........................
                int size;               // Kvobt@TCY
                n = getfunc(NULL, &size);
                if (0 == n) return; // vf̂ŏsv

                // 擾TCŸ̗m ....................
                size += sizeof(T) * 10;
                buf = (char *)malloc(size);
                if (NULL == buf) return; // s

                // f[^擾 ...............................
                n = getfunc(buf, &size);

                lim = buf + (sizeof(T) * n);
        }
 private:
        int n;
        char * buf;
        char * lim;
};

/*
 * a. ւ(\)Xg擾
 */
class GetMkaeList : public GetMkaeListBase<MkaeList_t> {
 public:
        GetMkaeList() : GetMkaeListBase<MkaeList_t>() {
                make(MkaeApi.GetList);
        }
        ~GetMkaeList() {
        }

        MkaeList_t *find(HWND hwnd) {
                for (MkaeList_t *p = first(); p != NULL; p = next(p)) {
                        if (p->hwnd_focused == hwnd)
                                return p;
                }
                return NULL;
        }
};

/*
 * b. ւ̓\񃊃Xg擾
 */
class GetMkaeInitialList : public GetMkaeListBase<MkaeInitialList_t> {
 public:
        GetMkaeInitialList() : GetMkaeListBase<MkaeInitialList_t>() {
                make(MkaeApi.GetInitialList);
        }
        ~GetMkaeInitialList() {
        }
};
#endif
