#ifndef MKAEPLUGIN_H
#define MKAEPLUGIN_H

#include <windows.h>

/*
 * PluginInfo_t : Mkae_OnGetPluginInfo()̍\
 */
#define MAX_PLGNAME 80
typedef struct PluginInfo {
        char name[MAX_PLGNAME]; /* vOC̖O */
} MkaePluginInfo_t;

/*
 * PluginMenu_t : Mkae_OnSetupRootMenu(), Mkae_OnSetupSubMenu() ̍\
 */
#define MAX_CAPTION  48
#define MAX_CALLBACK 80
#define MAX_SHORTCUT 24
#define MAX_CMDARGS  512
typedef struct PluginMenu {
        bool visible;           /* H */
        bool checked;           /* `FbN肩H */
        char caption[MAX_CAPTION]; /* \BuwEBhEIvȂ */
        char shortcut[MAX_SHORTCUT]; /* V[gJbgL[BuCtrl+KvȂ */
        char callback[MAX_CALLBACK]; /* IɌĂяo֐ */
        char cmdargs[MAX_CMDARGS]; /* R}h ukill -nvȂ*/
} MkaePluginMenu_t;

/*
 * MkaeStatus_t : GetStatus()̍\
 */
typedef struct MkaeStatus {
        bool has_focus;
} MkaeStatus_t;

/*
 * MkaeQuickOption_t : GetQuickOption()̍\
 */
enum e_winstyle {
        WINSTYLE_WINDOW,		/* EBhEX^C */
        WINSTYLE_LINE_BOTTOM,		/* CX^C, Œ */
        WINSTYLE_LINE_TOP,		/* CX^C, Œ */
        WINSTYLE_LINE_MOVABLE_STRECH,	/* CX^C, t */
        WINSTYLE_LINE_MOVABLE_FLOAT,	/* CX^C,  */
        WINSTYLE_LINE_APPBAR_BOTTOM,	/* CX^C, AppBar */
        WINSTYLE_LINE_APPBAR_TOP,	/* CX^C, AppBar */
};

enum e_liststyle {
        LISTSTYLE_EXE,			/* sX^C */
        LISTSTYLE_ALPH,			/* pX^C */
};

enum e_listsort {
        LISTSORT_DISP,			/* \ */
        LISTSORT_TIME,			/* N */
        LISTSORT_EXE,			/* st@C */
};

typedef struct MkaeQuickOption {
        bool is_stayontop;		/* ɍőOʂɕ\ */
        bool is_hideonlostfocus;	/* tH[JX\ */
        enum e_winstyle winstyle;	/* EBhEX^C */
        enum e_liststyle liststyle;	/* XgX^C */
        enum e_listsort listsort;	/* Xgя */
} MkaeQuickOption_t;

/*
 * MkaeList_t : GetList()̍\
 */
#define MAX_WINTEXT  256
typedef struct MkaeList {
        HWND hwnd;         /* Av{̂̃EBhEnh */
        HWND hwnd_focused; /* AṽtH[JX̂EBhEnh */
        char caption[MAX_WINTEXT]; /* ^Cgo[\ */
        bool is_custom; /* trueȂvOC쐬̃Ggł邱Ƃ\ */
} MkaeList_t;

typedef struct MkaeCustomList {
        HWND hwnd;         /* Av{̂̃EBhEnh */
        HWND hwnd_focused; /* AṽtH[JX̂EBhEnh */
        char caption[MAX_WINTEXT]; /* ^Cgo[\ */
        HICON hicon_s;
        HICON hicon_l;
} MkaeCustomList_t;

/*
 * MkaeInitialList_t : GetInitialList()̍\
 */
typedef struct MkaeInitialList {
        unsigned char alpha;    /* \񂵂p */
        char exename[MAX_PATH]; /* st@C */
        char caption[MAX_WINTEXT]; /* \ */
} MkaeInitialList_t;

/*
 * API:PrintErr
 */
#define MAX_LOGSIZ 256          /* Oo͉\ȃobt@ */

#endif /* MKAEPLUGIN_H */
