//
// EBhE1\邾̃TvłB
//   - ւ{̂̃zbgL[ł̕\/\ɕ\͘A܂B
//     -> ver.0.8.2.8, j[ũEBhE\v/
//        u`Bvŕ\/\ɕύX܂B
//   - EBhE̍W .iniɕۑ܂B
//

// C/C++ standard include file ------
#include <stdio.h>

// windows include file
#include <windows.h>

// plugin include file --------------
#include "../Plugin.h"
#include "../MkaeApi.h"
#include "../Log.h"
#include "../GetMkaeList.h"

#ifdef _MSC_VER
#define snprintf _snprintf_s
#endif

// global variables
HINSTANCE g_hinst;
HWND g_hwnd;
const char * g_classname  = "MadokaeDll_Sample1"; // ͕ςI
const char * g_pluginname = "Sample1";            // ͕ςI
char g_inifname[_MAX_PATH+2]; // `ۑpInit@C

MkaeAPI g_MkaeApi;
Log g_log;

// global variables -----------------
struct Features {
        int top, left;
        int width, hight;
} g_fea;

// global function prototypes -----
extern "C" __declspec(dllexport) void __stdcall MyCallBack1(const char *);
extern "C" __declspec(dllexport) void __stdcall MyCallBack2(const char *);
extern "C" __declspec(dllexport) void __stdcall MyCallBack_Option(const char *);
extern "C" __declspec(dllexport) void __stdcall MyCallBack_Version(const char *);

// static function prototypes -------
static int  DllProcessAttach(HINSTANCE hinstDLL, LPVOID lpvReserved);
static void DllProcessDetach(LPVOID lpvReserved);
static void PrintLastError();

LRESULT Wm_CreateProc(HWND,LPCREATESTRUCT);
LRESULT Wm_DestroyProc(HWND);
LRESULT Wm_LbuttonDown(HWND);
LRESULT CALLBACK SubWndProc(HWND, UINT, WPARAM, LPARAM);
BOOL    RegSubWindowClass(HINSTANCE, LPCSTR);

#ifdef __BORLANDC__
#pragma argsused
#endif
BOOL WINAPI
DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
        switch (fwdreason) {
        case DLL_PROCESS_ATTACH: {
                if (0 != DllProcessAttach(hinstDLL, lpvReserved))
                        return 0; // error
                break;
        }
        case DLL_THREAD_ATTACH:
                break;
        case DLL_THREAD_DETACH:
                break;
        case DLL_PROCESS_DETACH:
                DllProcessDetach(lpvReserved);
                break;
        } // end of switch(fwdreason)
        return 1;
}
//---------------------------------------------------------------------------
int
DllProcessAttach(HINSTANCE hinstDLL, LPVOID lpvReserved)
{
        g_hinst = (HINSTANCE) hinstDLL;

        // Log
        g_log.Init(hinstDLL);
#ifdef _MSC_VER
        g_log.Printf("compiled with VC\n");
#else
        g_log.Printf("compiled with BCB\n");
#endif

        // APIL
        if (false == g_MkaeApi.IsEnable())
                return -1; // error

        // ւ̃o[W擾 (菈͖쐬)
        char version[80];
        g_MkaeApi.GetVersion(version, sizeof(version));

        // <vOC>.ini ̍쐬
        char mdlname[_MAX_PATH+2];
        GetModuleFileName((HINSTANCE)hinstDLL, mdlname, _MAX_PATH);
        LPSTR pext = strrchr(mdlname, '.');
        if (pext) *pext = '\0';
        snprintf(g_inifname, sizeof(g_inifname), "%s.ini", mdlname);

        return 0;
}

void
DllProcessDetach(LPVOID lpvReserved)
{
        // nothing to do
}

void
PrintLastError()
{
        // GetLastError()l𕶎ɕϊ
        DWORD lsterr = GetLastError();
        LPTSTR bufp;
        FormatMessage(
                (FORMAT_MESSAGE_ALLOCATE_BUFFER |
                 FORMAT_MESSAGE_FROM_SYSTEM |
                 FORMAT_MESSAGE_IGNORE_INSERTS),
                NULL, lsterr, LANG_USER_DEFAULT,
                (LPTSTR)&bufp, 0, NULL);
        // CRLF
        int i = strlen(bufp) - 1;
        while(*(bufp + i) == '\r' || *(bufp + i) == '\n') {
                *(bufp + i) = '\0';
                i--;
        }
        // \
        g_MkaeApi.PrintErr(g_classname, "GetLastError()=%d:%s", lsterr, bufp);
        LocalFree(bufp);
}

//---------------------------------------------------------------------------

BOOL
RegSubWindowClass(HINSTANCE hInst, LPCSTR szClassName)
{
        WNDCLASSEX wc;
        wc.cbSize        = sizeof(WNDCLASSEX);
        wc.style         = CS_HREDRAW | CS_VREDRAW;
        wc.lpfnWndProc   = SubWndProc;
        wc.cbClsExtra    = 0;
        wc.cbWndExtra    = 0;
        wc.hInstance     = hInst;
        wc.hIcon         = NULL;
        wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
        wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
        wc.lpszMenuName  = NULL;
        wc.lpszClassName = szClassName;
        wc.hIconSm       = NULL;
        return RegisterClassEx(&wc);
}

LRESULT CALLBACK
SubWndProc(
        HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
        switch (uMsg) {
        case WM_CREATE:
                return Wm_CreateProc(hWnd,(LPCREATESTRUCT)lParam);
        case WM_LBUTTONDOWN:
                return Wm_LbuttonDown(hWnd);
        case WM_DESTROY:
                return Wm_DestroyProc(hWnd);
        default:
                return(DefWindowProc(hWnd, uMsg, wParam, lParam));
        }
}

// EBhE̐
LRESULT
Wm_CreateProc(HWND hWnd, LPCREATESTRUCT lpCs)
{
        return 0;
}

LRESULT
Wm_DestroyProc(HWND hWnd)
{
        return  0;
}

LRESULT
Wm_LbuttonDown(HWND hWnd)
{
        ReleaseCapture();
        SendMessage(hWnd, WM_SYSCOMMAND, SC_MOVE | 2, 0);
        return  0;
}

//---------------------------------------------------------------------------
// plugin, callback functions (K{֐)
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __stdcall
Mkae_OnGetPluginInfo(MkaePluginInfo_t * o_info)
{
        FUNCTRACE(g_log, "Mkae_OnGetPluginInfo");
        g_log.Printf("\to_info:0x%08x\n", o_info);
        
        memset(o_info, 0x0, sizeof(*o_info));
#ifdef _MSC_VER
        strncpy_s(o_info->name, sizeof(o_info->name),
                  g_pluginname, (sizeof(o_info->name)-1));
#else
        strncpy(o_info->name, g_pluginname, (sizeof(o_info->name)-1));
#endif
}

//---------------------------------------------------------------------------
// plugin, callback functions (Cӊ֐)
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) int __stdcall
Mkae_OnSetup(HWND i_hwnd_owner)
{
        FUNCTRACE(g_log, "Mkae_OnSetup");
        g_log.Printf("\ti_hwnd_owner:0x%08x\n",
                     i_hwnd_owner);

        // EBhENXo^
        if (0 == ::RegSubWindowClass(g_hinst, g_classname)) {
                PrintLastError();
                return -1; // error
        }

        // init@Cݒ̓ǂݍ
        g_fea.top   = ::GetPrivateProfileInt("Form", "Top", 0, g_inifname);
        g_fea.left  = ::GetPrivateProfileInt("Form", "Left", 0, g_inifname);
        g_fea.width = 200;
        g_fea.hight = 200;

        // EBhE̐
        g_hwnd = CreateWindowEx(
                (WS_EX_TOOLWINDOW),
                g_classname,
                "ւ̃Tv1",
                (WS_POPUPWINDOW | WS_THICKFRAME),
                g_fea.left, // XW
                g_fea.top, // YW
                g_fea.width, // 
                g_fea.hight, // 
                NULL,
                NULL,
                g_hinst,
                NULL);

        // 
        ShowWindow(g_hwnd, SW_HIDE);

        // ւtH[JXLɎhwndo^
        g_MkaeApi.RegisterFocus(g_hwnd);

        return 0;
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnSetupRootMenu(unsigned int * o_count, MkaePluginMenu_t * o_menu)
{
        FUNCTRACE(g_log, "Mkae_OnSetupRootMenu");
        g_log.Printf("\to_count:0x%08x, o_menu:0x%08x\n",
                     o_count, o_menu);

        MkaePluginMenu_t mymenu[] = {
                {1, 0, "Sample1_Callback1", "Alt+5", "MyCallBack1", "sample1 -f cb1"},
                {1, 0, "Sample1_Callback2", "Ctrl+Shift+L", "MyCallBack2", "sample1 -f cb2"},
        };

        // vfԂ
        *o_count = (sizeof(mymenu) / sizeof(mymenu[0]));

        if (o_menu != NULL) {
                // o_menuNULLłȂΓe
                memcpy(o_menu, &mymenu, sizeof(mymenu));
        }
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnSetupSubMenu(unsigned int * o_count, MkaePluginMenu_t * o_menu)
{
        FUNCTRACE(g_log, "Mkae_OnSetupSubMenu");
        g_log.Printf("\to_count:0x%08x, o_menu:0x%08x\n",
                     o_count, o_menu);

        MkaePluginMenu_t mymenu[] = {
                {1, 0, "GetList", "", "MyCallBack_GetList", ""},
                {1, 0, "GetHandleSelected", "", "MyCallBack_GetHandleSelected", ""},
                {1, 0, "GetFocusHandleSelected", "", "MyCallBack_GetFocusHandleSelected", ""},
                {1, 0, "GetItemIndexSelected", "", "MyCallBack_GetItemIndexSelected", ""},
                {1, 0, "GetGetHandleByItemIndex", "", "MyCallBack_GetHandleByItemIndex", ""},
                {1, 0, "GetGetFocusHandleByItemIndex", "", "MyCallBack_GetFocusHandleByItemIndex", ""},
                {1, 0, "GetQuickOption", "", "MyCallBack_GetQuickOption", ""},
                {1, 0, "-", "", "", ""}, // Zp[^
                {1, 0, "SetCursorByItemIndex", "", "MyCallBack_SetCursorByItemIndex", ""},
                {1, 0, "SetCursorByHandle", "", "MyCallBack_SetCursorByHandle", ""},
                {1, 0, "-", "", "", ""}, // Zp[^
                {1, 0, "ReMakeMenu", "", "MyCallBack_ReloadMenu", ""},
                {1, 0, "-", "", "", ""}, // Zp[^
                {1, 0, "̃EBhE\", "", "MyCallBack_ShowMyWindow", ""},
                {1, 0, "̃EBhEB", "", "MyCallBack_HideMyWindow", ""},
                {1, 0, "-", "", "", ""}, // Zp[^
                {1, 0, "ݒ", "Ctrl+Shift+O", "MyCallBack_Option", ""},
                {1, 0, "o[W", "Ctrl+Shift+V", "MyCallBack_Version", ""},
        };

        // vfԂ
        *o_count = (sizeof(mymenu) / sizeof(mymenu[0]));

        if (o_menu != NULL) {
                // o_menuNULLłȂΓe
                memcpy(o_menu, &mymenu, sizeof(mymenu));
        }
}

extern "C" __declspec(dllexport) int __stdcall
Mkae_OnTeardown()
{
        FUNCTRACE(g_log, "Mkae_OnTeardown()");

        // iniւ̏o擾
        RECT rect;
        GetWindowRect(g_hwnd, &rect); // EBhE`̎擾
        g_fea.top = rect.top;
        g_fea.left = rect.left;

        // init@C֐ݒo
        char work[20];
        snprintf(work, sizeof(work), "%d", g_fea.top);
        ::WritePrivateProfileString("Form", "Top", work, g_inifname);
        snprintf(work, sizeof(work), "%d", g_fea.left);
        ::WritePrivateProfileString("Form", "Left", work, g_inifname);

        // EBhENXo^
        UnregisterClass(g_classname, g_hinst);

        // ւtH[JXL肩玩hwndo^
        g_MkaeApi.UnregisterFocus(g_hwnd);

        // EBhEj
        DestroyWindow(g_hwnd);

        return 0;
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnShow()
{
        FUNCTRACE(g_log, "Mkae_OnShow()");
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnHide()
{
        FUNCTRACE(g_log, "Mkae_OnHide()");
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnActive()
{
        FUNCTRACE(g_log, "Mkae_OnActive()");
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnInactive()
{
        FUNCTRACE(g_log, "Mkae_OnInactive()");
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnUpdateList()
{
        FUNCTRACE(g_log, "Mkae_OnUpdateList()");
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnMoveCursor()
{
        FUNCTRACE(g_log, "Mkae_OnMoveCursor()");
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnRenameInitial(const char alph, const char * exename, const char * text)
{
        FUNCTRACE(g_log, "Mkae_OnRenameInitial");
        g_log.Printf("\talph:%c, exename:\"%s\", text:\"%s\"\n",
                     alph, exename, text);
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnWindowActive(const HWND i_hwnd)
{
        FUNCTRACE(g_log, "Mkae_OnWindowActive");
        g_log.Printf("\ti_hwnd:0x%08x\n", i_hwnd);
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnWindowActiveNotFound(const char alph, const char * exename)
{
        FUNCTRACE(g_log, "Mkae_OnWindowActiveNotFound");
        g_log.Printf("\talph:%c, exename:\"%s\"\n", alph, exename);
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnChangeQuickOption()
{
        FUNCTRACE(g_log, "Mkae_OnChangeQuickOption()");
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnSuspendHook(const bool is_suspend)
{
        FUNCTRACE(g_log, "Mkae_OnSuspendHook()");
}

// global function prototypes -----

extern "C" __declspec(dllexport) void __stdcall
MyCallBack1(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack1");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        MessageBox(g_hwnd, "Sample1::MyCallBack1", "callback", MB_OK);
}

extern "C" __declspec(dllexport) void __stdcall
MyCallBack2(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack2");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        MessageBox(g_hwnd, "Sample1::MyCallBack2", "callback", MB_OK);
}

// - get -----------------------------------------------------

extern "C" __declspec(dllexport) void __stdcall
MyCallBack_GetList(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack_GetList");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        int i = 0;
        class GetMkaeList mkaelist;
        for (MkaeList_t *p = mkaelist.first(); p != NULL; p = mkaelist.next(p)) {
                g_log.Printf("\tindex:%d\n", i++);
                g_log.Printf("\t  hwnd         = 0x%08x\n", p->hwnd);
                g_log.Printf("\t  hwnd_focused = 0x%08x\n", p->hwnd_focused);
                g_log.Printf("\t  caption      = \"%s\"\n", p->caption);
                g_log.Printf("\t  is_custom    = %d\n", p->is_custom ? 1 : 0);
        }
}

extern "C" __declspec(dllexport) void __stdcall
MyCallBack_GetHandleSelected(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack_GetHandleSelected");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        HWND hwnd = g_MkaeApi.GetHandleSelected();
        g_log.Printf("\tHWND:0x%08x = GetHandleSelected(\n", hwnd);
}

extern "C" __declspec(dllexport) void __stdcall
MyCallBack_GetFocusHandleSelected(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack_GetFocusHandleSelected");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        HWND hwnd = g_MkaeApi.GetFocusHandleSelected();
        g_log.Printf("\tHWND:0x%08x = GetFocusHandleSelected(\n", hwnd);
}

extern "C" __declspec(dllexport) void __stdcall
MyCallBack_GetItemIndexSelected(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack_GetItemIndexSelected");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        int item_index = g_MkaeApi.GetItemIndexSelected();
        g_log.Printf("\tint:%d = GetItemIndexSelected(\n", item_index);
}

extern "C" __declspec(dllexport) void __stdcall
MyCallBack_GetHandleByItemIndex(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack_GetHandleByItemIndex");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        // 擾
        int n;                  // vf
        int size;               // Kvobt@TCY
        n = g_MkaeApi.GetList(NULL, &size);
        if (0 == n) return;     // vf̂ŏsv

        for (int i=0; i < n; i++) {
                HWND hwnd = g_MkaeApi.GetHandleByItemIndex(i);
                g_log.Printf("\tHWND:0x%08x = GetHandleByItemIndex(%d)\n", hwnd, i);
        }
}

extern "C" __declspec(dllexport) void __stdcall
MyCallBack_GetFocusHandleByItemIndex(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack_GetFocusHandleByItemIndex");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        // 擾
        int n;                  // vf
        int size;               // Kvobt@TCY
        n = g_MkaeApi.GetList(NULL, &size);
        if (0 == n) return;     // vf̂ŏsv

        for (int i=0; i < n; i++) {
                HWND hwnd = g_MkaeApi.GetFocusHandleByItemIndex(i);
                g_log.Printf("\tHWND:0x%08x = GetFocusHandleByItemIndex(%d)\n", hwnd, i);
        }
}

extern "C" __declspec(dllexport) void __stdcall
MyCallBack_GetQuickOption(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack_GetQuickOption");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        MkaeQuickOption_t fea;
        g_MkaeApi.GetQuickOption(&fea);

        g_log.Printf("\tis_stayontop = %d\n", fea.is_stayontop);
        g_log.Printf("\tis_hideonlostfocus = %d\n", fea.is_hideonlostfocus);
        g_log.Printf("\twinstyle = %d\n", fea.winstyle);
        g_log.Printf("\tliststyle = %d\n", fea.liststyle);
}

// - set -----------------------------------------------------

extern "C" __declspec(dllexport) void __stdcall
MyCallBack_SetCursorByItemIndex(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack_SetCursorByItemIndex");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        // 
}

extern "C" __declspec(dllexport) void __stdcall
MyCallBack_SetCursorByHandle(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack_SetCursorByHandle");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        // 
}

extern "C" __declspec(dllexport) void __stdcall
MyCallBack_ReloadMenu(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack_ReloadMenu");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        g_MkaeApi.ReloadMenu(g_pluginname);
}

extern "C" __declspec(dllexport) void __stdcall
MyCallBack_ShowMyWindow(const char * i_cmdargs)
{
        ShowWindow(g_hwnd, SW_SHOWNORMAL);
        UpdateWindow(g_hwnd);
}

extern "C" __declspec(dllexport) void __stdcall
MyCallBack_HideMyWindow(const char * i_cmdargs)
{
        ShowWindow(g_hwnd, SW_HIDE);
}

// uݒvIƂɌĂ΂֐
extern "C" __declspec(dllexport) void __stdcall
MyCallBack_Option(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack_Option");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        MessageBox(g_hwnd, "@uݒvIɌĂ΂܂", "ݒ", MB_OK);
}

// uݒvIƂɌĂ΂֐
extern "C" __declspec(dllexport) void __stdcall
MyCallBack_Version(const char * i_cmdargs)
{
        FUNCTRACE(g_log, "MyCallBack_Version");
        g_log.Printf("\ti_cmdargs:\"%s\"\n", i_cmdargs);

        MessageBox(g_hwnd, "@uo[WvIɌĂ΂܂", "o[W", MB_OK);
}
